The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::VoicForm Class Reference

Four formant synthesis instrument. More...

`#include <VoicForm.h>`

Inheritance diagram for stk::VoicForm:

List of all members.

## Public Member Functions
| VoicForm (void)
| Class constructor.
| ~VoicForm (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
bool | setPhoneme (const char *phoneme)
| Set instrument parameters for the given phoneme. Returns false if phoneme not found.
void | setVoiced (StkFloat vGain)
| Set the voiced component gain.
void | setUnVoiced (StkFloat nGain)
| Set the unvoiced component gain.
void | setFilterSweepRate (unsigned int whichOne, StkFloat rate)
| Set the sweep rate for a particular formant filter (0-3).
void | setPitchSweepRate (StkFloat rate)
| Set voiced component pitch sweep rate.
void | speak (void)
| Start the voice.
void | quiet (void)
| Stop the voice.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

Four formant synthesis instrument.

This instrument contains an excitation singing wavetable (looping wave with random and periodic vibrato, smoothing on frequency, etc.), excitation noise, and four sweepable complex resonances.

Measured formant data is included, and enough data is there to support either parallel or cascade synthesis. In the floating point case cascade synthesis is the most natural so that's what you'll find here.

Control Change Numbers:

- Voiced/Unvoiced Mix = 2
- Vowel/Phoneme Selection = 4
- Vibrato Frequency = 11
- Vibrato Gain = 1
- Loudness (Spectral Tilt) = 128

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::VoicForm::VoicForm | ( | void |  | ) |

Class constructor.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

StkFrames & stk::VoicForm::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

    00133 {
    00134   unsigned int nChannels = lastFrame_.channels();
    00135 #if defined(_STK_DEBUG_)
    00136   if ( channel > frames.channels() - nChannels ) {
    00137     oStream_ << "VoicForm::tick(): channel and StkFrames arguments are incompatible!";
    00138     handleError( StkError::FUNCTION_ARGUMENT );
    00139   }
    00140 #endif
    00141
    00142   StkFloat *samples = &frames[channel];
    00143   unsigned int j, hop = frames.channels() - nChannels;
    00144   if ( nChannels == 1 ) {
    00145     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00146       *samples++ = tick();
    00147   }
    00148   else {
    00149     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00150       *samples++ = tick();
    00151       for ( j=1; j<nChannels; j++ )
    00152         *samples++ = lastFrame_[j];
    00153     }
    00154   }
    00155
    00156   return frames;
    00157 }

The documentation for this class was generated from the following file:

- VoicForm.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.